<template>
  <div v-if="store && user">
    <PageTemplate type="album" :data="store" />

    <el-upload
      v-if="store.user_id === user.id"
      :id="$route.params.id"
      where="album"
      multiple
    />

    <Feed
      v-if="media.length"
      v-loading="loading"
      :data="media"
      :counter="true"
      :moderate="true"
      type="album"
    />
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  useContext,
  ref,
  computed,
  useMeta
} from '@nuxtjs/composition-api'

import { useGetStoreQuery, useMediaSubscription } from '@/sdk/hooks'
import { StoreFragment, MediaFileFragment } from '@/sdk/types'

import PageTemplate from '@/components/template/PrivatePage.vue'
import elUpload from '@/components/element/Upload.vue'
import Feed from '@/components/ui/Feed.vue'

export default defineComponent({
  name: 'PrivateAlbumPage',
  components: {
    PageTemplate,
    Feed,
    elUpload
  },
  head: {},
  setup(_, { root }) {
    const { app, route, error } = useContext()
    const user = computed(() => root.$accessor.auth.user)

    const meta = useMeta()
    const store = ref<StoreFragment>([] as any)
    const { onResult } = useGetStoreQuery({
      id: root.$route.params.id as string
    })
    if (process.client) {
      onResult(result => {
        if (result?.data?.store) {
          store.value = result.data.store
        }
      })
    }

    // upload photos && output media
    const pageSize = ref(2000)
    const media = ref<MediaFileFragment[]>([])
    const { onResult: mediaResult, loading } = useMediaSubscription(
      computed(() => ({
        where: {
          store_id: { _eq: root.$route.params.id }
        },
        limit: pageSize.value,
        offset: 0
      }))
    )
    mediaResult(result => {
      if (result?.data?.media_files) {
        media.value = result.data.media_files
      }
    })

    const counterUpload = ref(0)
    const onUploadPhoto = async (file: File) => {
      try {
        await app.$api.storage.upload(
          `public/web/media/${Date.now()}.jpg`,
          file,
          {
            type: 'store',
            object_id: root.$route.params.id,
            private: true
          }
        )
        // root.$message({
        //   message: 'Uploading, you can continue browse',
        //   type: 'success'
        // })
        //counterUpload.value++
      } catch (e) {
        // counterUpload.value = 0
        // root.$message({
        //   message: 'Sorry, something wrong 😩',
        //   type: 'error'
        // })
      } finally {
      }
    }

    return {
      user,
      media,
      store,
      onUploadPhoto,
      counterUpload
    }
  }
})
</script>
